<script lang="ts">
  import { onMount } from 'svelte';
  // @ts-ignore I have no idea why this won't work 😭
  import { useSessionStorage, useLocalStorage } from 'sveltronics';
  import { Button } from 'flowbite-svelte';
  import Fa from 'svelte-fa';
  import { faXmark } from '@fortawesome/free-solid-svg-icons';
  import { writable, type Writable } from 'svelte/store';

  export { clazz as class };
  export let slug: String;
  export let buttonClass = "mr-5 rounded-lg p-1.5 text-secondary hover:text-white bg-none hover:bg-secondary focus:outline-none"
  export let storage: "session" | "local" | undefined = undefined;

  // default class displays like a banner
  let clazz = 'w-full bg-cyber-blue-900';
  let show: Writable<boolean>;

  onMount(() => {
    if (storage === "session") {
      show = useSessionStorage(slug, true);
    } else if (storage === "local") {
      show = useLocalStorage(slug, true);
    } else {
      show = writable(true);
    }
  });
</script>

{#if $show}
  <div
    class="flex items-center justify-center {clazz}">
    <slot name="content" />
    <Button
      color="none"
      class={buttonClass}
      data-umami-event="Hide {slug}"
      on:click={() => $show = false}>
      <Fa size="lg" icon={faXmark} />
    </Button>
  </div>
{/if}
